+++
date = 2021-08-06T10:32:57Z
description = ""
draft = false
slug = "security-of-iot"
title = "Security of IoT"
tags = ["security"]

+++


## Security of IoT

### **IoT란?**

IoT (Internet of Things)란, 사물인터넷으로, 예전에는 독립적으로 존재했던 각종 전자기기 및 사물들이 인터넷으로 엮여 한번에 관리할 수 있게 되거나, 상호 정보교환과 데이터 수집을 통해 사용자에게 최상의 서비스를 제공하는 기술을 의미이다. 여기에서 사물이라 함은 모든 사물을 포함한다. 데이터를 분석하는 과정에서 인공지능을 주로 사용하므로 IoT는 인공지능 기술이기도 하다.

IoT는 2013년부터 쭉 개발되어 왔으며, 우리 집에서 흔히 볼 수 있는 에어컨, 냉장고등 큰 가구들부터 연결되어 왔다. 그 이후 시간이 지나면서 점점 작은 기구들까지 연결되면서, TV, 전자레인지, 오븐부터 커피포트, 선풍기, 전등 뿐 아니라 변기, 샤워기, 거울, 헤어 드라이기까지 연결되어 있지 않은 것이 없을 정도로 발전되어 왔다.

IoT 서비스 제공자들은 사용자들의 데이터를 분석하는 더욱 발전한 알고리즘을 개발하면서 사용자들의 데이터를 수집한다. 이것들은 모여 방대한 빅 데이터가 된다. 물론 고객의 개인정보 무단수집과 남용의 논란도 계속 이어져 왔지만, 서비스를 이용하기 위해서 어쩔 수 없이 개인정보와 사생활을 팔아야 하는 것은 안타까운 일이다.

### **IoT 보안**

IoT에서는 보안이 매우 중요하다. 개인의 사생활을 담당하고 있기도 하지만, 생활환경을 조정할 수 있어 자칫하면 목숨까지 위협할 수 있기 떄문이다. IoT기기는 소형화되어 있으며, 또한 저성능으로 구성되고 하드웨어에 접근이 쉽다는 근거로 해킹에 매우 취약하다. 또한, 자동화된 생산에서 만약 반도체 설계부터 문제가 있거나 트로이 목마가 존재한다면 매우 심각하고 영구적인 보안 결함이 될 것이다. 따라서, 반도체 설계, 생산 과정에서 모듈 점검을 정확하게 진행하여야 하며, 점대점(Point-to-Point) 보안을 확립하는 것이 중요하다. 또한, 저성능 프로세서에 대비하기 위해 주변에 보안칩(암호 Co-Processor)를 장치하는 것이 좋다. 소프트웨어적인 보안은 업데이트하기 용이하고, 대처하기 쉽다는 장점이 있지만, 하드웨어 보안을 확립한다면 그것이 거의 필요없을 뿐 아니라 물리적 보안, 암호 알고리즘, 보안 부팅, 키 암호화, 모듈 서명 등 다양한 보안 기능과 해킹 방지를 탑재하고 있어, 이를 확립하는 것이 무엇보다 중요하다.

반도체 물리적 복제 방지 (PUF)나 보안 칩(TPF)등의 탑재가 가장 중요할 것이며, 이는 키가 소프트웨어적으로 탈취당할 확률을 기하급수적으로 낮춰주며, Side-Channel Attack에 대한 방어까지 탐재하는 것이 좋을 것이다.

